/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2010 C ARIOUAT - assia.ariouat@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.dgfip.xemelios.controls.demandeachat;

import java.util.Hashtable;
import java.util.Stack;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;

/**
 * Le champ ADDR_ORIGIN ne peut être valorisé que par A ou B
 * @author Assia ARIOUAT
 */
public class M168 extends AbstractUnitControl {
    public static final String CTRL_ID = "CTL-M168" ;
    public static final transient String RESET_COUNTER_PATH = "FEN0067A/DA/";
    public static final transient String CHEMIN_ENTETE_IDAE = "FEN0067A/DA/ENTETE/ID_AE/";
    public static final transient String CHEMIN_ADDR_ORIGIN = "FEN0067A/DA/PARTENAIRE/ADDR_ORIGIN/";
    public static final transient String CHEMIN_IDPARTENAIRE = "FEN0067A/DA/PARTENAIRE/ID_AE/";
    public static final transient String CHEMIN_PARTENAIRE = "FEN0067A/DA/PARTENAIRE/";
    public static final transient String CHEMIN_ID_LIG= "FEN0067A/DA/PARTENAIRE/ID_LIG/";
    public static final transient String RETURN_ANOMALIES_PATH = RESET_COUNTER_PATH;
    private static final Logger logger = Logger.getLogger(M168.class);

    // pour stocker tous les paramètres d'execution des controles
    private Hashtable<String,Object> hParams;

    private String ID_DA = null;
	private String ID_DA_Unique = "";
    private String  addr_origin = "";
    private String addr_origin_Nod = "";
    private String idIDPARTENAIRE = "";
	private String numLigneTexte = "";
	private String id_lig = "";

    
    //pour le message d'erreurs
    private static final String MSG_IDPARTENAIRE = "#IDPARTENAIRE#";
	private static final String MSG_ADDR_ORIGIN = "#ADDR_ORIGIN#";
    private static final String MSG_ID_LIG = "#ID_LIG#";

       
    // pour récupérer le texte des balises
    private Stack<StringBuffer> chars = new Stack<StringBuffer>();

    // pour stocker les anomalies que l'on génère
    Vector<Anomalie> anomalies = null;

    public void endDocument() throws SAXException { }

    public void startElement(String uri, String localName, String qName, Attributes atts, String xpath) throws SAXException {
        if(xpath.equals(RESET_COUNTER_PATH)) {           
            anomalies = new Vector<Anomalie>();
            ID_DA = "";            
            ID_DA_Unique = atts.getValue("ano:unique-id");            
        } else if(xpath.equals(CHEMIN_PARTENAIRE)) {
        	addr_origin = "";  
        	idIDPARTENAIRE=id_lig="";
        	addr_origin_Nod = "";
        } else if(xpath.equals(CHEMIN_ADDR_ORIGIN)) {
        	addr_origin_Nod = atts.getValue("ano:node-id");
        }
        
        chars.push(new StringBuffer());
    }

    public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
    	
    		if(xpath.equals(CHEMIN_ENTETE_IDAE)) {
    			ID_DA = chars.peek().toString();}
    		else if (xpath.equals(CHEMIN_IDPARTENAIRE)){
    				idIDPARTENAIRE=chars.peek().toString();
    			}
    		else if(xpath.equals(CHEMIN_ID_LIG)) {
    			id_lig = chars.peek().toString();
			}
    		 else if(xpath.equals(CHEMIN_ADDR_ORIGIN)) {
    			 addr_origin = chars.peek().toString();
    			
    				if(!addr_origin.equals("A") && !addr_origin.equals("B")) {       	
        	
	        			String anoId = IdGenerator.nextId();
	                    Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
	                    xslParams.put("anoId", anoId);
	                    xslParams.put("presentation","src");
	                    String libelleLien = "DA_ID "+ID_DA;
	                    String path = "@ano:unique-id='" + ID_DA_Unique + "'";
	                    // on reconstitue le message
	                    String msg = (numLigneTexte.length()>0?"Ligne n°"+numLigneTexte+" : ":"");
	        			msg += getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
	        			msg = msg.replace("#DA_ID#", ID_DA);
	                    msg = msg.replaceAll(MSG_IDPARTENAIRE, idIDPARTENAIRE);
	        			msg = msg.replaceAll(MSG_ADDR_ORIGIN, addr_origin);
	        			msg = msg.replaceAll(MSG_ID_LIG, id_lig);
	                    Anomalie ano = new Anomalie(anoId,
	                            getDocumentModel().getControlById(CTRL_ID),
	                            getDocumentModel().getDocumentId(),
	                            "FEN0067A",
	                            "DA",
	                            ID_DA,
	                            localName,  // l'élément en anomalie est bien DA
	                            libelleLien,
	                            msg,
	                            getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
	                            getDocumentModel().getControlById(CTRL_ID).getSeverity(),
	                            path,
	                            xslParams);
	                    ano.addNode(new Node(addr_origin_Nod));
	                    anomalies.add(ano);
    				}
		            chars.pop();
		            return null;
        } else if(xpath.equals(RETURN_ANOMALIES_PATH)){
        	chars.pop();
            return anomalies;
        }
        chars.pop();
        return null;
    }

    public void characters(char[] ch, int start, int length, String xpath) throws SAXException {
        // on met les caractères lus dans la pile
        chars.peek().append(ch, start, length);
    }

    public void ignorableWhitespace(char[] ch, int start, int length, String xpath) throws SAXException { }

    public void processingInstruction(String target, String data, String xpath) throws SAXException { }

    public void skippedEntity(String name, String xpath) throws SAXException { }

    public void setParameters(Hashtable<String, Object> params) {
        this.hParams=params;
    }

    public void setDocumentLocator(Locator locator) { }

    public void startDocument() throws SAXException { }

    public void startPrefixMapping(String prefix, String uri, String xpath) throws SAXException { }

    public void endPrefixMapping(String prefix, String xpath) throws SAXException { }
}
